#include <fstream>
#include <vector>
using namespace std;

ifstream fin("carti.in");
ofstream fout("carti.out");

vector<bool> win;
int t, n, k, init_mask, mask;

string s;
int main()
{
    fin >> t;
    for (int i = 1; i <= t; ++i)
    {
        fin >> n >> k;
        init_mask = 0;
        for (int j = 1; j <= n; ++j)
        {
            fin >> s;
            if (s[0] == '1')
                init_mask |= (1 << 9);
            else if (s[0] == 'A')
                ++init_mask; // init_mask |= 1
            else if (s[0] == 'J')
                init_mask |= (1 << 10);
            else if (s[0] == 'Q')
                init_mask |= (1 << 11);
            else if (s[0] == 'K')
                init_mask |= (1 << 12);
            else init_mask |= (1 << (s[0] - '0' - 1));
        }

        win = vector<bool>(init_mask + 1);
        for (int i = 0; i < init_mask; ++i)  // i - o submultime de carti din configuratia data
            if (win[i] == false)
                for (int l = 1; l <= k; ++l)  // jucatorul curent ia l carti
                {
                    for (mask = (1 << l) - 1; mask + i <= init_mask; mask <<= 1)      //  mask = (1 << l) - 1;  masca numai cu 1 de lung l
                        if ((mask & i) == 0)       // intersectie
                            win[mask | i] = true;  // reuniune
                }

        if (win[init_mask])
            fout << "Alice\n";
        else fout << "Bob\n";
    }
    fin.close();
    fout.close();
    return 0;
}
